
#Reverse Animation v1.0
#created BY http://steamcommunity.com/id/OMGTheresABearInMyOatmeal/

import sfmApp,sfm





def GetChannels(control):
    
    if control.GetTypeString()=='DmElement':
        
        if control.HasAttribute("rightvaluechannel"):
            return control.rightvaluechannel,control.leftvaluechannel
        else:
            return control.channel,None
        
    elif control.GetTypeString()=='DmeTransformControl':
        return control.positionChannel,control.orientationChannel



def ReverseSelectedDagAnimation():
    sfmApp.SetTimelineMode(4)   
    

    sfm.SetOperationMode( "Record" ) 

    if sfmApp.GetDocumentRoot().settings.timeSelection.IsEitherInfinite():
        StartTime=sfmApp.GetShotAtCurrentTime().GetStartTime()+vs.DmeTime_t(5.0)
        EndTime=sfmApp.GetShotAtCurrentTime().GetEndTime()+vs.DmeTime_t(5.0)
    else:
        StartTime=sfmApp.GetDocumentRoot().settings.timeSelection.GetValue("hold_left")+vs.DmeTime_t(5.0)
        EndTime=sfmApp.GetDocumentRoot().settings.timeSelection.GetValue("hold_right")+vs.DmeTime_t(5.0)
    
    controlList=sfmApp.GetDocumentRoot().settings.graphEditorState.activeControlList
    
    
    for activeControl in controlList:
        
        
        FirstChannel,SecondChannel =GetChannels(activeControl)


        FirstChannel_start_Index=FirstChannel.log.FindKeyWithinTolerance(StartTime,vs.DmeTime_t(100.0))
        FirstChannel_End_Index=FirstChannel.log.FindKeyWithinTolerance(EndTime,vs.DmeTime_t(100.0))
        

        FirstChannelvaluelist= FirstChannel.log.GetLayer(0).values
      #  FirstChanneltimelist= FirstChannel.log.GetLayer(0).times

   
        Rev_FirstChannelvaluelist=[]    
       # Rev_FirstChanneltimelist=[]
        

        #startpoint=FirstChanneltimelist[FirstChannel_start_Index]
        #create list with revered value order
        if FirstChannel.log.GetKeyCount()>2:
            for i in range(FirstChannel_start_Index,FirstChannel_End_Index+1):
                Rev_FirstChannelvaluelist.insert(0,FirstChannelvaluelist[i])
                #if (i+1)>FirstChannel_End_Index:
                    #break
                #startpoint+=(FirstChanneltimelist[i+1]-FirstChanneltimelist[i])
                #Rev_FirstChanneltimelist.append(startpoint)
                
                
            for i in range(FirstChannel_start_Index,FirstChannel_End_Index+1):
                FirstChannelvaluelist[i]=Rev_FirstChannelvaluelist[i-FirstChannel_start_Index]
                #if (i+1)>FirstChannel_End_Index:
                    #break                
                #FirstChanneltimelist[i]=Rev_FirstChanneltimelist[i-FirstChannel_start_Index]
                
                
                
        if SecondChannel and SecondChannel.log.GetKeyCount()>2:
            SecondChannel_start_Index=SecondChannel.log.FindKeyWithinTolerance(StartTime,vs.DmeTime_t(100.0))
            SecondChannel_End_Index=SecondChannel.log.FindKeyWithinTolerance(EndTime,vs.DmeTime_t(100.0))            
            SecondChannelvalue=SecondChannel.log.GetLayer(0).values
            
            SecondChanneltime=SecondChannel.log.GetLayer(0).times
            Rev_SecondChannelvaluelist=[]
           # Rev_SecondChanneltimelist=[]
            
            
            #startpoint=SecondChanneltime[SecondChannel_start_Index]
            
            
            for i in range(SecondChannel_start_Index,SecondChannel_End_Index+1):
                Rev_SecondChannelvaluelist.insert(0,SecondChannelvalue[i])
                #if (i+1)>SecondChannel_End_Index:
                    #break
                #startpoint+=(SecondChanneltime[i+1]-SecondChanneltime[i])
                #Rev_SecondChanneltimelist.append(startpoint)                
                
       
            for i in range(SecondChannel_start_Index,SecondChannel_End_Index+1):  
                SecondChannelvalue[i]=Rev_SecondChannelvaluelist[i-SecondChannel_start_Index]
                #if (i+1)>SecondChannel_End_Index:
                    #break                
                #SecondChanneltime[i]=Rev_SecondChanneltimelist[i-SecondChannel_start_Index]
                





    sfmApp.SetTimelineMode(2)
    sfm.SetOperationMode( "Pass" )

ReverseSelectedDagAnimation()
del ReverseSelectedDagAnimation


